#include <DMXSerial.h>

/*
  DMX/Random-Ansteuerung für analoge Scopes

  DMX-Modus mit gesteckter Brücke: Änderungen auf Adresse 90 lösen einen Blitz aus
  Random-Modus ohne Brücke: Pseudo-Random Blitze für Sylvester mit max 2sec Blitzabstand

  V1.0 20200105 First Release
*/

const int STRBCTRL =  2;      // Digital Pin 2
const int MODESW =  3;      // Digital Pin 3 ist umschalter DMX oder Random

long randNumber;

int   iMode = 0;    // 0: DMX 1: Strbo
int   iDMXdata = 0;
int   iDMXdata_old = 0;

// the setup function runs once when you press reset or power the board
void setup() {
  DMXSerial.init(DMXReceiver);
  // initialize digital pins
  pinMode(MODESW, INPUT_PULLUP);
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode(STRBCTRL, OUTPUT);
  digitalWrite(STRBCTRL, HIGH);

  if (digitalRead(MODESW)== HIGH) {
    iMode = 1; 
  }
}

void trigger_strobo() {
    digitalWrite(LED_BUILTIN, HIGH);  // turn the LED on (HIGH is the voltage level)
    digitalWrite(STRBCTRL, LOW);      // Puls auf Trigger-Ausgang
    delay(14);                       // wait 
    digitalWrite(LED_BUILTIN, LOW);   // turn the LED off by making the voltage LOW
    digitalWrite(STRBCTRL, HIGH);  
}

// the loop function runs over and over again forever
void loop() {

  if ( iMode==1) {

    trigger_strobo();
    randNumber = random(14, 2000);
    delay(randNumber);                       // wait for a second
  }
  else {
    iDMXdata = DMXSerial.read(90);

    // Beim Wert 0 (Dunkel) nicht flashen
    if (iDMXdata == 0) {
      iDMXdata_old = 0;
    }
    // Bei Änderung Blitz auslösen
    if (iDMXdata != iDMXdata_old){
          iDMXdata_old = iDMXdata;
          trigger_strobo();
    }
    
     
 
  }
  
  
}
